#include "WProgram.h"
#include "a034.h"

ALDL::ALDL(int pin)
{
	pinMode(pin,OUTPUT);
	_pin = pin;
	disp_counter=0;
	DataStreamCounter=0;

}

ALDL::~ALDL()
{
	// Nada
}


void ALDL::calc_data(void) {
	unsigned int temp;

	//Calculate coolant N = (DEG C + 40)*256/192
	//Deg C = 192x/256 - 40
	CarData[CAR_CTS] = ((192*DataStream[DEF_CTS])/256) - 40; 

	//Calculate startup coolant N = (DEG C + 40)*256/192
	//Deg C = 192x/256 - 40
	CarData[CAR_STRTCOOL] = ((192*DataStream[DEF_STRTCOOL])/256) - 40; 

	//Calculate Throttle Position voltage
	//Volts = N/51
	CarData[CAR_TPS] = DataStream[DEF_TPS]/51;

	//Rescaled Throttle Position, calculated as percentage
	CarData[CAR_RTPS] = DataStream[DEF_RTPS] * 100 / 255;

	//RPM
	CarData[CAR_RPM] = DataStream[DEF_RPM] * 25;

	//Filtered MPH
	CarData[CAR_MPH] = DataStream[DEF_MPH];

	//O2Sensor Millivolts
	CarData[CAR_O2S] = DataStream[DEF_O2S] * 4.44;

	//IAC Difference
	CarData[CAR_IACDF] = DataStream[DEF_IACD] - DataStream[DEF_IACP];

	//RPM Desired
	CarData[CAR_RPMD] = DataStream[DEF_RPMD] * 12.5;

	//RPM Idle Desired
	CarData[CAR_RPMID] = DataStream[DEF_RPMID] * 12.5;

	//Barometer VOLTS = N * .0196
	CarData[CAR_BARO] = DataStream[DEF_BARO] * 0.0196;

	//MANIFOLD ABSOLUTE PRESSURE VOLTS = N * .0196
	CarData[CAR_MAP] = DataStream[DEF_MAP] * 0.0196;

	//MAP LOAD VARIABLE KPA=N/3.2
	CarData[CAR_MAPLV] = DataStream[DEF_MAPLV] / 3.2;

	//Vacuum VOLTS = N * .0196
	CarData[CAR_VACUUM] = DataStream[DEF_VACUUM] * 0.0196;

	//MANIFOLD ABSOULUTE TEMPERATURE  DEGREES C = N*192/256-40
	CarData[CAR_MAT] = ((192*DataStream[DEF_MAT])/256) - 40; 

	//Battery Voltage
	CarData[CAR_BATT] = DataStream[DEF_BATT] / 10;

	//Spark Advace Degrees DEGREES = N * 90/256
	CarData[CAR_SPAD] = DataStream[DEF_SPAD] * 90/256;

	//Desired A/F Ration
	CarData[CAR_DAFR] = DataStream[DEF_DAFR] / 10;

	//Desired A/F Ratio cranking
	CarData[CAR_CAFR] = DataStream[DEF_CAFR] / 10;

	//CarData[CAR_] = DataStream[DEF_]
}

