#ifndef ___A034___
#define ___A034___
#include "WProgram.h"

#define DataStreamSize  68    //Size of receiving data stream
#define CarDataInt      19    //Size of Array to display

class ALDL
{
public:
	ALDL(int pin);
	~ALDL();
	void out_data();
	void calc_data();
	int CarData[CarDataInt];
	volatile unsigned char DataStream[DataStreamSize];
	volatile int DataStreamCounter;
	int disp_counter; //used to re-display header info
private:
	int _pin;
};

//unsigned char DataStream[DataStreamSize];
#define  Def_Offset     3
#define  DEF_PROMIDA    1 + Def_Offset
#define  DEF_PROMIDB    2 + Def_Offset
#define  DEF_ERROR1     3 + Def_Offset
#define  DEF_ERROR2     4 + Def_Offset
#define  DEF_ERROR3     5 + Def_Offset
#define  DEF_CTS        6 + Def_Offset  //N = (DEG C + 40)*256/192
#define  DEF_STRTCOOL   7 + Def_Offset  //N = (DEG C + 40)*256/192
#define  DEF_TPS        8 + Def_Offset  //VOLTS = N/51
#define  DEF_RTPS       9 + Def_Offset  //Rescaled TPS
#define  DEF_RPM        10 + Def_Offset //RPM = N * 25
#define  DEF_MPH        13 + Def_Offset //Filtered MPH  MPH=N
#define  DEF_O2S        15 + Def_Offset //MILLIVOLTS = N*4.44
#define  DEF_CLI        20 + Def_Offset	//Closed Loop Integrator
#define  DEF_IACP       21 + Def_Offset	//IAC Present Motor Position
#define  DEF_IACD       22 + Def_Offset	//IAC Desired Motor Position
#define  DEF_RPMD       23 + Def_Offset //RPM Desired = N * 12.5
#define  DEF_RPMID      24 + Def_Offset //RPM Desired Idle = N * 12.5
#define  DEF_BARO       25 + Def_Offset  // BAROMETER  volts = N X .0196
#define  DEF_MAP        26 + Def_Offset    // volts = N x .0196
#define  DEF_MAPLV      27 + Def_Offset  //MAP LOAD VARIABLE    KPA = N/3.2                                          
#define  DEF_VACUUM     28 + Def_Offset  // VOLTS = N x 0.0196
#define  DEF_MAT        29 + Def_Offset  //MANIFOLD ABSOULUTE TEMPERATURE  DEGREES C = N*192/256-40
#define  DEF_BATT       31 + Def_Offset   // volts = N / 10
#define  DEF_SPAD       32 + Def_Offset  //Spark Advace Degrees DEGREES = N * 90/256
#define  DEF_DAFR       37 + Def_Offset	// Desired A/F RATIO = N * .1
#define  DEF_CAFR       38 + Def_Offset	// A/F RATIO while cranking = N * .1

//int CarData[CarDataInt];
#define CAR_CTS       0 //Coolant Celcius
#define CAR_STRTCOOL  1 //Start Coolant Celcius
#define CAR_TPS       2  //TPS Volts
#define CAR_RTPS      3  //Rescaled TPS
#define CAR_RPM       4  //RPM
#define CAR_MPH       5  //MPH Filtered
#define CAR_O2S       6  //O2 Sensor Millivolts
#define CAR_IACDF     7  // IAC Difference
#define CAR_RPMD      8  // RPM Desired
#define CAR_RPMID     9 // RPM Idle Desired
#define CAR_BARO     10  //Barometer
#define CAR_MAP      11
#define CAR_MAPLV    12  //KPA
#define CAR_VACUUM   13
#define CAR_MAT      14
#define CAR_BATT     15
#define CAR_SPAD     16  // Spark Advance Degrees
#define CAR_DAFR     17 //Desired A/F Ratio
#define CAR_CAFR     18 //Cranking A/F Ratio

#endif
